#ifndef FITNESS_H
#define FITNESS_H

#include <eo>
#include <iostream>   // cout
#include <iomanip>

#include "ind_strategy.h" 

#include "compete.h" 

using namespace std; 



class DummyFitness : public eoPopEvalFunc<Indi> {

public:



  void operator()(eoPop<Indi> & _parents, eoPop<Indi> & _offspring) {

    // tady muzeme prepocitat fitness rodicum 
    // a spocitat fitness potomkum 

    // napr. nechat soutezit kazdeho s kazdym a 
    // vzit vysledne skore jako fitness 

    // mozno vyuzit tridu Compete (compete.h)

    for (unsigned i=0; i<_offspring.size(); i++) 
      _offspring[i].fitness( 0.0 );

    for (unsigned i=0; i<_parents.size(); i++) 
      _parents[i].fitness( 0.0 ); 

  } 

private:
  Compete compete;
  vector<double> rewards;

};  

#endif
