#ifndef KNIGHT_H
#define KNIGHT_H

class Knight : public Strategy {
public:
  Knight() { reset();  }
  int operator()() { return response; }
  virtual void reset() {last_reward = -1; response = COOPERATE; }
  virtual void reward(int _reward) {
  switch (last_reward){
    case -1:
      if (_reward == CD) response = DECEIVE;
      if (_reward == CC) response = COOPERATE;
      last_reward = -2;
      break;
    case -2:
      if (_reward == CD) response = DECEIVE;
      if (_reward == CC) response = COOPERATE;
      last_reward = _reward;
      break;
    case CC:
      if (_reward == CD) response = DECEIVE;
      if (_reward == DC) response = COOPERATE;
      if (_reward == CC) response = COOPERATE;
      if (_reward == DD) response = DECEIVE;
      last_reward = _reward;
      break;
    case CD:
      if (_reward == CD) response = DECEIVE;
      if (_reward == DC) response = COOPERATE;
      if (_reward == CC) response = COOPERATE;
      if (_reward == DD) response = DECEIVE;
      last_reward = _reward;
      break;
    case DD:
      if (_reward == CD) response = DECEIVE;
      if (_reward == DC) response = COOPERATE;
      if (_reward == CC) response = COOPERATE;
      if (_reward == DD) response = DECEIVE;
      last_reward = _reward;
      break;
    case DC:
      if (_reward == CD) response = DECEIVE;
      if (_reward == DC) response = DECEIVE;
      if (_reward == CC) response = COOPERATE;
      if (_reward == DD) response = COOPERATE;
      last_reward = _reward;
      break;
    }
  }
  virtual string getName() { return "Knight"; }
private:
  int response;
  int last_reward;
};

#endif
